<?php
// transfer.inc.php
//
// Component of SecureTrading STPP Payment Pages module for CubeCart 4

if (!defined('CC_INI_SET')) die("Access Denied");

function repeatVars(){

		return false;

}

function fixedVars() {
	// Build the form to POST to SecureTrading
	global $db, $module, $orderSum, $cc_session, $config;

// Currency setup, if it's not specified in the order (it wasn't on our Development tests) then use the store default currency
if(empty($orderSum['currency'])) {
	$currency = $config['defaultCurrency'];
}

// SecureTrading needs the Customer and Billing names split into first and last name(s) for fraud detection. Since some names will have more than 2 components,
// we'll do a generic process on the name field, the customer can correct it on the Payment Page if we are wrong.
$stName = explode(" ", $orderSum['name']);
$stSurname = array_pop($stName);
$stForename = implode(" ", $stName);

$stName_d = explode(" ", $orderSum['name_d']);
$stSurname_d = array_pop($stName_d);
$stForename_d = implode(" ", $stName_d);


	// Note: SecureTrading requires a telephone "type" to be set, but it's not explicitly set in CubeCart, we just default it to "H" in the module
	//	 There is a separate area for Mobile (which we don't use) so the only confusion would be if a Work number is entered. But it's not terrible.
	//    2: CubeCart only uses one email address for an order and doesn't allow for separate billing and delivery emails. No reason for these to be
	//	 different in most cases, but since ST can cater for both, we just send the billing email over for each field. This is also the case for telephone.
	//    3: The module has to split the single-field "name" provided by CubeCart into a forename and surname. The module uses a generic method to achieve this
	//	 which is implemented in a function, developers are welcome to implement their own name formatting method in this function should they wish. 
	$hiddenVars = 	"<input type='hidden' name='sitereference' value='".$module['siteRef']."' />
			 <input type='hidden' name='version' value='1' />
			 <input type='hidden' name='mainamount' value='".$orderSum['prod_total']."' />
			 <input type='hidden' name='currencyiso3a' value='".$currency."' />

			 <input type='hidden' name='billingpremise' value='" .$orderSum['add_1']. "' />
			 <input type='hidden' name='billingtown' value='" .$orderSum['town']."' />
			 <input type='hidden' name='billingcounty' value='" .$orderSum['county']. "' />
			 <input type='hidden' name='billingpostcode' value='" .$orderSum['postcode']. "' />
			 <input type='hidden' name='billingfirstname' value='" .$stForename. "' />
			 <input type='hidden' name='billinglastname' value='" .$stSurname. "' />
			 <input type='hidden' name='billingcountryiso2a' value='" .getCountryFormat($orderSum['country'],'id','iso'). "' />
			 <input type='hidden' name='billingemail' value='" .$orderSum['email']. "' />
			 <input type='hidden' name='billingtelephone' value='" .$orderSum['phone']. "' />
			 <input type='hidden' name='billingtelephonetype' value='H' />

			 <input type='hidden' name='customerpremise' value='" .$orderSum['add_1_d'] . "' />
			 <input type='hidden' name='customertown' value='" .$orderSum['town_d'] . "' />
			 <input type='hidden' name='customercounty' value='" .$orderSum['county_d'] . "' />
			 <input type='hidden' name='customerpostcode' value='" .$orderSum['postcode_d'] . "' />
			 <input type='hidden' name='customercountryiso2a' value='" .getCountryFormat($orderSum['country_d'], 'printable_name', 'iso') . "' />
			 <input type='hidden' name='customeremail' value='" .$orderSum['email'] . "' />
			 <input type='hidden' name='customertelephone' value='" .$orderSum['phone'] . "' />
			 <input type='hidden' name='customertelephonetype' value='H' />
			 <input type='hidden' name='customerfirstname' value='" .$stForename_d. "' />
			 <input type='hidden' name='customerlastname' value='" .$stSurname_d. "' />
			 <input type='hidden' name='customerid' value='" .$orderSum['customer_id']. "' /> 
			 <input type='hidden' name='orderreference' value='" .$orderSum['cart_order_id']. "' />";



		// If security hash feature is enabled..
		if($module['useHash'] == "on") {
			$hiddenVars .= "<input type='hidden' name='sitesecurity' value='" .createHash($module, $orderSum, $currency) . "' />";
		}
		return $hiddenVars;
}


	function createHash($module, $orderSum, $currency) {
	// Build the Security Hash to send with the POST. Although the Payment Pages system allows MD5 hashes, SHA-256 is more secure.
		$pattern = str_replace(" ", "",$module['hashFields']); // remove any spaces from pattern
		$patterns = explode(",",$pattern); // get an array of elements used in pattern

		$securitystring = "";

		foreach($patterns as $element) {
			switch($element) {
				case "sitereference":	$securitystring .= $module['siteRef'];
								break;
				case "amount":		$securitystring .= $orderSum['prod_total'];
								break;
				case "currency":	$securitystring .= $currency;
								break;
			}
		}

		// Add password to hash string
		$securitystring .= $module['hashPass'];

		return hash("sha256", $securitystring);
	}



$formAction = "https://payments.securetrading.net/process/payments/choice";
$formMethod = "post";
$formTarget = "_self";
$transfer = "auto"; // Changing this to "auto" requires "form.inc.php" to be present for CubeCart to display a form and submit button.

?>
